"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _gitCommitTask = _interopRequireDefault(require("./subTasks/gitCommitTask"));

var _gitMessageTask = _interopRequireDefault(require("./subTasks/gitMessageTask"));

var _npmHookTask = _interopRequireDefault(require("./subTasks/npmHookTask"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const gitTask = async (argv, {
  edit,
  hook
}) => {
  await (0, _npmHookTask.default)(argv, {
    task: 'git',
    type: 'pre'
  });

  switch (hook) {
    case 'commit':
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'commit'],
        type: 'pre'
      });
      await (0, _gitCommitTask.default)(argv);
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'commit'],
        type: 'post'
      });
      break;

    case 'msg':
      if (typeof edit !== 'string' || edit.trim() === '') {
        throw new Error(`Argument "edit" is required at hook "${hook}"`);
      }

      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'msg'],
        type: 'pre'
      });
      await (0, _gitMessageTask.default)(argv, {
        edit
      });
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'msg'],
        type: 'post'
      });
      break;

    default:
      throw new Error(`The hook "${hook}" is unknown`);
  }

  await (0, _npmHookTask.default)(argv, {
    task: 'git',
    type: 'post'
  });
};

var _default = gitTask;
exports.default = _default;