"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _jest = _interopRequireWildcard(require("../actions/tools/jest"));

var _spinner = require("../cli/spinner");

var _mkdir = _interopRequireDefault(require("../cmd/mkdir"));

var _getTestProjects = _interopRequireDefault(require("./helpers/getTestProjects"));

var _npmHookTask = _interopRequireDefault(require("./subTasks/npmHookTask"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const testTask = async (argv, props) => {
  await (0, _npmHookTask.default)(argv, {
    task: 'test',
    type: 'pre'
  });
  const projectList = await (0, _getTestProjects.default)(argv, undefined, props.coverage);
  const projects = await (0, _getTestProjects.default)(argv, props.project, props.coverage); // create a coverage folder

  await (0, _mkdir.default)((0, _path.join)(argv.cwd, _jest.coverageFolderName));

  if (props.watch || props.coverage) {
    /* eslint-disable-next-line no-restricted-syntax */
    for (const project of projects) {
      /* eslint-disable-next-line no-await-in-loop */
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'pre'
      });
    }

    if (props.coverage) {
      await (0, _spinner.spinnerAction)((0, _jest.default)(argv, { ...props,
        projectList,
        project: projects
      }), 'Jest: coverage');
    } else {
      await (0, _jest.default)(argv, { ...props,
        projectList,
        project: projects
      });
    }
    /* eslint-disable-next-line no-restricted-syntax */


    for (const project of projects) {
      /* eslint-disable-next-line no-await-in-loop */
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'post'
      });
    }
  } else {
    /* eslint-disable-next-line no-restricted-syntax */
    for (const project of projects) {
      /* eslint-disable no-await-in-loop */
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'pre'
      });
      await (0, _spinner.spinnerAction)((0, _jest.default)(argv, { ...props,
        projectList,
        project
      }), `Jest: ${project}`);
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'post'
      });
      /* eslint-enable no-await-in-loop */
    }
  }

  await (0, _npmHookTask.default)(argv, {
    task: 'test',
    type: 'post'
  });
};

var _default = testTask;
exports.default = _default;